@version 2.3
@warnings
@script generic

/*
======================================================================
script to be used to add remove or update plugins.

www.Steelronin.com
Scott@steelronin.com
======================================================================
*/

@name SR_Add-Remove_plugins
scriptName = "SR Add/Remove Plugins v0.1.2";
copyright = "Copyright (c) 2005 Scott lange";

/*
version notes
v0.1.2 Add a quick option interface to work for any plugin
v0.1.1 add proper checking to only remove morph mixer
add an update option
v0.1.0 only supports morph mixer plugin
*/




generic
{

    // base input values

    c1 = 1;
    c2 = 1;
    c3 = "plg_Curve_Bone";

    // perform all processing here
    scene = Scene();
    selList = scene.getSelect();
   
    if(selList == nil)
    {
        error("<br>You must select an item.");
        return;
    }
    
//    if(selList[1].genus != MESH)
//        error("This only works on objects");

    // reverse selList order
    listcopy = selList;
    for(a=1;a<=size(listcopy);a++)
        selList[(size(listcopy)+1) - a]=listcopy[a];

    // interface
    reqbegin(scriptName);

    //define callback var
    c1 = ctlchoice("Choice",c1,@"object","Displacment","Motion"@);

    c2 = ctlchoice("Choice",c2,@"Add","Remove","Update"@);

    c3 = ctlstring("Plugin Name",c3);

    if(!reqpost()) return;
    c1Choice = getvalue(c1);
    c2Choice = getvalue(c2);
    c3_pName = getvalue(c3);

    reqend();

   
    // setup variables

    n = size(selList);

    //select object and gather info
    for(i = 1;i <= n;i++)
    {  // loop 1
        SelectItem(selList[i].id);
        if(c1Choice == 1)
        {
            OHapplied = selList[i].server("CustomObjHandler");
            if(c2Choice == 1)
            {
                ApplyServer("CustomObjHandler",c3_pName); // add motion modifyer to bake the target rotation
            }
            
            if(c2Choice == 2)
            {
                counter = size(OHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(OHapplied[x] == c3_pName)
                    {
                        RemoveServer("CustomObjHandler",x); // remove the morph mixer modifer
                        break;
                    }
                }    
            }
            if(c2Choice == 3)
            {
                counter = size(OHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(OHapplied[x] == c3_pName)
                    {
                        RemoveServer("CustomObjHandler",x); // remove the morph mixer modifer
                        break;
                    }
                }
                ApplyServer("CustomObjHandler",c3_pName); // add Displacment modifyer
            }
        }

        if(c1Choice == 2)
        {
            DHapplied = selList[i].server("DisplacementHandler");
            if(c2Choice == 1)
            {
                ApplyServer("DisplacementHandler",c3_pName); // add motion modifyer to bake the target rotation
            }
            
            if(c2Choice == 2)
            {
                counter = size(DHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(DHapplied[x] == c3_pName)
                    {
                        RemoveServer("DisplacementHandler",x); // remove the morph mixer modifer
                        break;
                    }
                }    
            }
            if(c2Choice == 3)
            {
                counter = size(DHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(DHapplied[x] == c3_pName)
                    {
                        RemoveServer("DisplacementHandler",x); // remove the morph mixer modifer
                        break;
                    }
                }
                ApplyServer("DisplacementHandler",c3_pName); // add Displacment modifyer
            }
        }

        if(c1Choice == 3)
        {
            MHapplied = selList[i].server("ItemMotionHandler");
            if(c2Choice == 1)
            {
                ApplyServer("ItemMotionHandler",c3_pName); // add motion modifyer
            }
            
            if(c2Choice == 2)
            {
                counter = size(MHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(MHapplied[x] == c3_pName)
                    {
                        RemoveServer("ItemMotionHandler",x); // remove the modifer
                        break;
                    }
                }    
            }
            if(c2Choice == 3)
            {
                counter = size(MHapplied);
    
                for(x = 1; x <= counter; x++) //loop 2
                {
                    if(mHapplied[x] == c3_pName)
                    {
                        RemoveServer("ItemMotionHandler",x); // remove the  modifer
                        break;
                    }
                }
                ApplyServer("ItemMotionHandler",c3_pName); // add motion modifyer 
            }
        }
    }

    // reselect items

    SelectItem(selList[1].id);
    for(n=2;n<=size(selList);n++)
       AddToSelection(selList[n].id);
}
